// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	fsTagsFieldNames          = builder.RawFieldNames(&FsTags{})
	fsTagsRows                = strings.Join(fsTagsFieldNames, ",")
	fsTagsRowsExpectAutoSet   = strings.Join(stringx.Remove(fsTagsFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	fsTagsRowsWithPlaceHolder = strings.Join(stringx.Remove(fsTagsFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	fsTagsModel interface {
		Insert(ctx context.Context, data *FsTags) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*FsTags, error)
		Update(ctx context.Context, data *FsTags) error
		Delete(ctx context.Context, id int64) error
	}

	defaultFsTagsModel struct {
		conn  sqlx.SqlConn
		table string
	}

	FsTags struct {
		Id                   int64          `db:"id"`                     // ID
		Title                string         `db:"title"`                  // 标题
		Level                int64          `db:"level"`                  // 层级、分类 1 => 二维码分类
		ClickNum             int64          `db:"click_num"`              // 点击次数
		Sort                 int64          `db:"sort"`                   // 排序(从大到小)
		CreateAt             int64          `db:"create_at"`              // 创建时间
		Icon                 sql.NullString `db:"icon"`                   // 标签图标
		Status               int64          `db:"status"`                 // 状态 1：可用
		Description          string         `db:"description"`            // 介绍 Seo
		RecommendProduct     sql.NullString `db:"recommend_product"`      // 推荐产品id例如: 1,3,4,5
		RecommendProductSort sql.NullString `db:"recommend_product_sort"` // 推荐排序例如:1324
	}
)

func newFsTagsModel(conn sqlx.SqlConn) *defaultFsTagsModel {
	return &defaultFsTagsModel{
		conn:  conn,
		table: "`fs_tags`",
	}
}

func (m *defaultFsTagsModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultFsTagsModel) FindOne(ctx context.Context, id int64) (*FsTags, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", fsTagsRows, m.table)
	var resp FsTags
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultFsTagsModel) Insert(ctx context.Context, data *FsTags) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?, ?)", m.table, fsTagsRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.Title, data.Level, data.ClickNum, data.Sort, data.Icon, data.Status, data.Description, data.RecommendProduct, data.RecommendProductSort)
	return ret, err
}

func (m *defaultFsTagsModel) Update(ctx context.Context, data *FsTags) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, fsTagsRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.Title, data.Level, data.ClickNum, data.Sort, data.Icon, data.Status, data.Description, data.RecommendProduct, data.RecommendProductSort, data.Id)
	return err
}

func (m *defaultFsTagsModel) tableName() string {
	return m.table
}
